/*
 * usb_pwr.h
 *
 *  Created on: 21.05.2010
 *      Author: AndreR
 */

#ifndef USB_PWR_H_
#define USB_PWR_H_

#include "stm32f10x.h"

#include "usb_lib.h"

// PWR
typedef enum _RESUME_STATE
{
	RESUME_EXTERNAL,
	RESUME_INTERNAL,
	RESUME_LATER,
	RESUME_WAIT,
	RESUME_START,
	RESUME_ON,
	RESUME_OFF,
	RESUME_ESOF
} RESUME_STATE;

typedef enum _DEVICE_STATE
{
	UNCONNECTED,
	ATTACHED,
	POWERED,
	SUSPENDED,
	ADDRESSED,
	CONFIGURED
} DEVICE_STATE;

void Suspend(void);
void Resume_Init(void);
void Resume(RESUME_STATE eResumeSetVal);
RESULT PowerOn(void);
RESULT PowerOff(void);

extern  __IO uint32_t bDeviceState; /* USB device status */
extern __IO uint8_t fSuspendEnabled;  /* true when suspend is possible */

#endif /* USB_PWR_H_ */
