#include "fifo8.h"

void FifoInit(Fifo8* pFIFO, uint8_t* pData, uint16_t Size)
{
	pFIFO->pData = pData;
	pFIFO->Size = Size;
	pFIFO->pDataEnd = (pFIFO->pData + pFIFO->Size - 1);

	FifoClear(pFIFO);
}

void FifoClear(Fifo8* pFIFO)
{
	pFIFO->pWrite = pFIFO->pData;
	pFIFO->pRead = pFIFO->pData;
	pFIFO->EmptyBytes = pFIFO->Size;
}

void FifoPush(Fifo8* pFIFO, uint8_t Byte)
{
	*pFIFO->pWrite = Byte;
	if(pFIFO->pWrite == pFIFO->pDataEnd)
		pFIFO->pWrite = pFIFO->pData;
	else
		pFIFO->pWrite++;

	pFIFO->EmptyBytes--;
}

void FifoPop(Fifo8* pFIFO, uint8_t* pByte)
{
	*pByte = *pFIFO->pRead;

	if(pFIFO->pRead == pFIFO->pDataEnd)
		pFIFO->pRead = pFIFO->pData;
	else
		pFIFO->pRead++;

	pFIFO->EmptyBytes++;
}
