/* Define memory spaces. */
MEMORY
{
  ram (rwx) : ORIGIN = 0x20000000, LENGTH = 64K
  rom (rx) : ORIGIN = 0x08000000, LENGTH = 512K
}

_estack = ORIGIN(ram) + LENGTH(ram);

OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm", "elf32-littlearm")

ENTRY(Reset_Handler)

SECTIONS
{
	.text : 
    {
    	. = ALIGN(4);
		KEEP(*(.isr_vector))
		. = ALIGN(4);
    	*(.rom)
    	*(.rom.b)
        *(.text .text.* .gnu.linkonce.t.*)        /* Program code */
        *(.gnu.warning)
        *(.glue_7)
        *(.glue_7t)
        *(.rodata .rodata.* .gnu.linkonce.r.*)      /* Read only data */
        . = ALIGN(8);
    	_etext = .;
    	_sidata = _etext;
    } >rom
    
    .data : AT(_sidata) 
    {
    	_sdata = .;
        *(.data .data.* .gnu.linkonce.d.*)	/* Data memory */
        *(.ram)
        . = ALIGN(8);
        _edata = .;
    } >ram

    .bss : 
    {
    	_sbss = .;
        *(.bss .bss.* .gnu.linkonce.b.*)	/* Zero-filled run time allocate data memory */
        *(.ram.b)
        . = ALIGN(8);
        _ebss = .;
        end = .;
    } >ram
}  
