/*
 * *********************************************************
 * Copyright (c) 2009 - 2010, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - RCU
 * Date: 06.11.2010
 * Author(s): Lukas
 * 
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.robotcontrolutility.model;

import java.io.Serializable;


/**
 * This class contains all needed attributes for a command.
 * 
 * @author Lukas
 * 
 */

public class ActionCommand implements Serializable
{
	// --------------------------------------------------------------------------
	// --- instance variables ---------------------------------------------------
	// --------------------------------------------------------------------------
	private static final long	serialVersionUID	= -68111792087214485L;
	public final double			translateX;
	public final double			translateY;
	public final double			rotate;
	public final double			force;
	public final double			chipKick;
	public final double			pass;
	public final double			arm;
	public final double			dribble;
	
	
	// --------------------------------------------------------------------------
	// --- constructor(s) -------------------------------------------------------
	// --------------------------------------------------------------------------
	public ActionCommand(double translateY, double translateX, double rotate, double force, double chipKick,
			double pass, double arm, double dribble)
	{
		this.translateY = translateY;
		this.translateX = translateX;
		this.rotate = rotate;
		this.force = force;
		this.chipKick = chipKick;
		this.pass = pass;
		this.arm = arm;
		this.dribble = dribble;
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	public boolean equals(ActionCommand ac)
	{
		boolean result = true;
		if (ac == null)
		{
			result = false;
		} else if (this.translateX != ac.translateX || this.translateY != ac.translateY || this.rotate != ac.rotate
				|| this.force != ac.force || this.chipKick != ac.chipKick || this.pass != ac.pass || this.arm != ac.arm
				|| this.dribble != ac.dribble)
		{
			result = false;
		}
		return result;
	}
}
