/*
 * *********************************************************
 * Copyright (c) 2009 DHBW Mannheim - Tigers Mannheim
 * Project: tigers-robotControlUtility
 * Date: 19.11.2010
 * Authors: Clemens Teichmann <clteich@gmx.de>
 * *********************************************************
 */
package edu.dhbw.mannheim.tigers.robotcontrolutility.view;

import java.awt.*;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.util.*;

import javax.swing.*;
import net.java.games.input.Controller;
import net.miginfocom.swing.MigLayout;
import edu.dhbw.mannheim.tigers.robotcontrolutility.presenter.AControllerPresenter;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.actions.ButtonSelectAction;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.actions.DefaultConfigAction;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.actions.LoadConfigAction;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.actions.SaveConfigAction;


/**
 * This code was edited or generated using CloudGarden's Jigloo
 * SWT/Swing GUI Builder, which is free for non-commercial
 * use. If Jigloo is being used commercially (ie, by a corporation,
 * company or business for any purpose whatever) then you
 * should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details.
 * Use of Jigloo implies acceptance of these licensing terms.
 * A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
 * THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
 * LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */

/**
 * @author Clemens
 * 
 */
public class ControllerPanel extends javax.swing.JPanel
{
	// --------------------------------------------------------------------------
	// --- class variables ------------------------------------------------------
	// --------------------------------------------------------------------------
	private static final long				serialVersionUID	= -1995301908447097243L;
	
	// --- GUI Components ---
	private JPanel								robotChoicePanel;
	private JPanel								movementPanel;
	private JPanel								activityPanel;
	private JLabel								serverLabel;
	private JTextField						leftTextField;
	private JButton							defaultConfigButton;
	private JButton							loadConfigButton;
	private JButton							saveConfigButton;
	private JPanel								configManagePanel;
	private JLabel								leftLabel;
	private JTextField						backwardTextField;
	private JLabel								backwardLabel;
	private JTextField						forwardTextField;
	private JLabel								forwardLabel;
	private JTextField						forceTextField;
	private JTextField						armTextField;
	private JLabel								armLabel;
	private JTextField						dribbleTextField;
	private JLabel								dribbleLabel;
	private JTextField						rotateRightTextField;
	private JLabel								rotateRightLabel;
	private JTextField						rotateLeftTextField;
	private JLabel								rotateLeftLabel;
	private JTextField						chipKickTextField;
	private JLabel								chipKickLabel;
	private JLabel								forceLabel;
	private JTextField						passTextField;
	private JLabel								passLabel;
	private JTextField						rightTextField;
	private JLabel								rightLabel;
	private JLabel								portLabel;
	private JTextField						serverTextField;
	private JTextField						portTextField;
	

	/**
	 * HashMap with all TextFields
	 * Key : Action (TextField Name)
	 * Value : TextField
	 */
	private HashMap<String, JTextField>	tFMap					= new HashMap<String, JTextField>();
	
	// --- Controller Informations
	private Controller						controller;
	private AControllerPresenter			controllerPresenter;
	
	// --- portnumber, automatic increment per panel ---
	private static int						portNumber			= 10009;
	
	
	/**
	 * Auto-generated main method to display this
	 * JPanel inside a new JFrame.
	 */
	
	// -----------------------------------------------------------------
	// ----- Constructor -----------------------------------------------
	// -----------------------------------------------------------------
	public ControllerPanel(Controller newController, AControllerPresenter newControllerPresenter)
	{
		super();
		controller = newController;
		controllerPresenter = newControllerPresenter;
		portNumber++;
		initGUI();
	}
	

	// -----------------------------------------------------------------
	// ----- Methods ---------------------------------------------------
	// -----------------------------------------------------------------
	
	// --- initiate ControllerPanel GUI ---
	private void initGUI()
	{
		try
		{
			// --- set general preferences for controllerPanel ---
			MigLayout thisLayout = new MigLayout();
			thisLayout.setRowConstraints("[135.0][fill]");
			thisLayout.setColumnConstraints("[297.0]");
			this.setLayout(thisLayout);
			this.setPreferredSize(new java.awt.Dimension(541, 291));
			{
				// --- robot choice panel with server and port ---
				robotChoicePanel = new JPanel();
				MigLayout robotChoicePanelLayout = new MigLayout();
				robotChoicePanelLayout.setRowConstraints("30.0[25.0][25.0]");
				robotChoicePanelLayout.setColumnConstraints("[89.0][121.0]");
				robotChoicePanel.setLayout(robotChoicePanelLayout);
				this.add(robotChoicePanel, "cell 0 0");
				robotChoicePanel.setPreferredSize(new java.awt.Dimension(297, 199));
				robotChoicePanel.setBorder(BorderFactory.createTitledBorder("Connection Information"));
				{
					serverLabel = new JLabel();
					robotChoicePanel.add(serverLabel, "cell 0 0");
					serverLabel.setText("Server:");
				}
				{
					// --- Server to connect ---
					serverTextField = new JTextField();
					robotChoicePanel.add(serverTextField, "cell 1 0");
					serverTextField.setText("192.168.77.10");
					serverTextField.addFocusListener(new FocusListener()
					{
						public void focusLost(FocusEvent arg0)
						{
						}
						

						public void focusGained(FocusEvent arg0)
						{
							serverTextField.selectAll();
						}
					});
					serverTextField.setPreferredSize(new java.awt.Dimension(149, 20));
				}
				{
					portLabel = new JLabel();
					robotChoicePanel.add(portLabel, "cell 0 1");
					portLabel.setText("Port:");
				}
				{
					// --- choose Bot using his port ---
					portTextField = new JTextField();
					robotChoicePanel.add(portTextField, "cell 1 1");
					portTextField.addFocusListener(new FocusListener()
					{
						public void focusLost(FocusEvent arg0)
						{
						}
						

						public void focusGained(FocusEvent arg0)
						{
							portTextField.selectAll();
						}
					});
					portTextField.setText("" + portNumber);
					portTextField.setPreferredSize(new java.awt.Dimension(139, 20));
				}
			}
			{
				// --- panel with all movement commands ---
				movementPanel = new JPanel();
				MigLayout movementPanelLayout = new MigLayout();
				movementPanelLayout.setRowConstraints("[fill][fill][fill][]");
				movementPanelLayout.setColumnConstraints("[70.0][80.0]");
				movementPanel.setLayout(movementPanelLayout);
				this.add(movementPanel, "cell 0 1");
				movementPanel.setPreferredSize(new java.awt.Dimension(262, 133));
				{
					forwardLabel = new JLabel();
					movementPanel.add(forwardLabel, "cell 0 0");
					forwardLabel.setText("Forward: ");
				}
				{
					/*
					 * just comment one ActionTextfield completly
					 * for all similar
					 */

					// --- forward action ---
					forwardTextField = new JTextField();
					// --- add Textfield to Panel first ---
					movementPanel.add(forwardTextField, "cell 1 0");
					// --- set Size ---
					forwardTextField.setPreferredSize(new java.awt.Dimension(87, 20));
					// --- TextField name = Action ---
					forwardTextField.setName("forward");
					// --- mouseListener to set configuration ---
					forwardTextField.addMouseListener(new ButtonSelectAction(forwardTextField, controller,
							controllerPresenter));
					// --- not editable by user ---
					forwardTextField.setEditable(false);
					// --- reset color to white (setEditable(false) turns textfield grey) ---
					forwardTextField.setBackground(Color.white);
					// --- put Action and Textfield on HashMap ---
					tFMap.put(forwardTextField.getName(), forwardTextField);
				}
				{
					backwardLabel = new JLabel();
					movementPanel.add(backwardLabel, "cell 0 1");
					backwardLabel.setText("Backwards: ");
				}
				{
					// --- backward action ---
					backwardTextField = new JTextField();
					movementPanel.add(backwardTextField, "cell 1 1");
					backwardTextField.setPreferredSize(new java.awt.Dimension(85, 20));
					backwardTextField.setName("backward");
					backwardTextField.addMouseListener(new ButtonSelectAction(backwardTextField, controller,
							controllerPresenter));
					backwardTextField.setEditable(false);
					backwardTextField.setBackground(Color.white);
					tFMap.put(backwardTextField.getName(), backwardTextField);
				}
				{
					leftLabel = new JLabel();
					movementPanel.add(leftLabel, "cell 0 2");
					leftLabel.setText("Left: ");
				}
				{
					// --- left action ---
					leftTextField = new JTextField();
					movementPanel.add(leftTextField, "cell 1 2");
					leftTextField.setPreferredSize(new java.awt.Dimension(85, 20));
					leftTextField.setName("left");
					leftTextField.addMouseListener(new ButtonSelectAction(leftTextField, controller, controllerPresenter));
					leftTextField.setEditable(false);
					leftTextField.setBackground(Color.white);
					tFMap.put(leftTextField.getName(), leftTextField);
				}
				{
					rightLabel = new JLabel();
					movementPanel.add(rightLabel, "cell 0 3");
					rightLabel.setText("Right:");
				}
				{
					// --- right action ---
					rightTextField = new JTextField();
					movementPanel.add(rightTextField, "cell 1 3");
					rightTextField.setPreferredSize(new java.awt.Dimension(86, 20));
					rightTextField.setName("right");
					rightTextField.addMouseListener(new ButtonSelectAction(rightTextField, controller, controllerPresenter));
					rightTextField.setEditable(false);
					rightTextField.setBackground(Color.white);
					tFMap.put(rightTextField.getName(), rightTextField);
				}
				{
					rotateLeftLabel = new JLabel();
					movementPanel.add(rotateLeftLabel, "cell 2 0");
					rotateLeftLabel.setText("Rotate Left:");
				}
				{
					// --- rotate left action ---
					rotateLeftTextField = new JTextField();
					movementPanel.add(rotateLeftTextField, "cell 3 0");
					rotateLeftTextField.setPreferredSize(new java.awt.Dimension(81, 20));
					rotateLeftTextField.setName("rotateLeft");
					rotateLeftTextField.addMouseListener(new ButtonSelectAction(rotateLeftTextField, controller,
							controllerPresenter));
					rotateLeftTextField.setEditable(false);
					rotateLeftTextField.setBackground(Color.white);
					tFMap.put(rotateLeftTextField.getName(), rotateLeftTextField);
				}
				{
					rotateRightLabel = new JLabel();
					movementPanel.add(rotateRightLabel, "cell 2 1");
					rotateRightLabel.setText("Rotate Right: ");
				}
				{
					// --- rotate right action ---
					rotateRightTextField = new JTextField();
					movementPanel.add(rotateRightTextField, "cell 3 1");
					rotateRightTextField.setPreferredSize(new java.awt.Dimension(83, 20));
					rotateRightTextField.setName("rotateRight");
					rotateRightTextField.addMouseListener(new ButtonSelectAction(rotateRightTextField, controller,
							controllerPresenter));
					rotateRightTextField.setEditable(false);
					rotateRightTextField.setBackground(Color.white);
					tFMap.put(rotateRightTextField.getName(), rotateRightTextField);
				}
			}
			{
				// --- panel with all activity commands ---
				activityPanel = new JPanel();
				MigLayout actionPanelLayout = new MigLayout();
				actionPanelLayout.setColumnConstraints("[70.0][80.0]");
				actionPanelLayout.setRowConstraints("[][][]");
				activityPanel.setLayout(actionPanelLayout);
				this.add(activityPanel, "cell 1 1");
				activityPanel.setPreferredSize(new java.awt.Dimension(261, 135));
				{
					passLabel = new JLabel();
					activityPanel.add(passLabel, "cell 0 0");
					passLabel.setText("Pass:");
				}
				{
					// --- pass action ---
					passTextField = new JTextField();
					activityPanel.add(passTextField, "cell 1 0");
					passTextField.setPreferredSize(new java.awt.Dimension(87, 20));
					passTextField.setName("pass");
					passTextField.addMouseListener(new ButtonSelectAction(passTextField, controller, controllerPresenter));
					passTextField.setEditable(false);
					passTextField.setBackground(Color.white);
					tFMap.put(passTextField.getName(), passTextField);
				}
				{
					forceLabel = new JLabel();
					activityPanel.add(forceLabel, "cell 0 1");
					forceLabel.setText("Force" + ": ");
				}
				{
					// --- force action ---
					forceTextField = new JTextField();
					activityPanel.add(forceTextField, "cell 1 1");
					forceTextField.setPreferredSize(new java.awt.Dimension(85, 20));
					forceTextField.setName("force");
					forceTextField.addMouseListener(new ButtonSelectAction(forceTextField, controller, controllerPresenter));
					forceTextField.setEditable(false);
					forceTextField.setBackground(Color.white);
					tFMap.put(forceTextField.getName(), forceTextField);
				}
				{
					chipKickLabel = new JLabel();
					activityPanel.add(chipKickLabel, "cell 0 2");
					chipKickLabel.setText("Chip Kick: ");
				}
				{
					// --- chip kick action ---
					chipKickTextField = new JTextField();
					activityPanel.add(chipKickTextField, "cell 1 2");
					chipKickTextField.setPreferredSize(new java.awt.Dimension(90, 20));
					chipKickTextField.setName("chipKick");
					chipKickTextField.addMouseListener(new ButtonSelectAction(chipKickTextField, controller,
							controllerPresenter));
					chipKickTextField.setEditable(false);
					chipKickTextField.setBackground(Color.white);
					tFMap.put(chipKickTextField.getName(), chipKickTextField);
				}
				{
					dribbleLabel = new JLabel();
					activityPanel.add(dribbleLabel, "cell 0 3");
					dribbleLabel.setText("Dribble: ");
				}
				{
					// --- dribble action ---
					dribbleTextField = new JTextField();
					activityPanel.add(dribbleTextField, "cell 1 3");
					dribbleTextField.setPreferredSize(new java.awt.Dimension(85, 20));
					dribbleTextField.setName("dribble");
					dribbleTextField.addMouseListener(new ButtonSelectAction(dribbleTextField, controller,
							controllerPresenter));
					dribbleTextField.setEditable(false);
					dribbleTextField.setBackground(Color.white);
					tFMap.put(dribbleTextField.getName(), dribbleTextField);
				}
				{
					armLabel = new JLabel();
					activityPanel.add(armLabel, "cell 0 4");
					armLabel.setText("Arm: ");
				}
				{
					// --- arm action ---
					armTextField = new JTextField();
					activityPanel.add(armTextField, "cell 1 4");
					armTextField.setPreferredSize(new java.awt.Dimension(83, 20));
					armTextField.setName("arm");
					armTextField.addMouseListener(new ButtonSelectAction(armTextField, controller, controllerPresenter));
					armTextField.setEditable(false);
					armTextField.setBackground(Color.white);
					tFMap.put(armTextField.getName(), armTextField);
				}
			}
			{
				// --- panel to manage configurations ---
				configManagePanel = new JPanel();
				MigLayout configManagePanelLayout = new MigLayout();
				configManagePanelLayout.setColumnConstraints("[60.0][64.0][75.0]");
				configManagePanel.setLayout(configManagePanelLayout);
				this.add(configManagePanel, "cell 1 0");
				configManagePanel.setPreferredSize(new java.awt.Dimension(261, 35));
				configManagePanel.setBorder(BorderFactory.createTitledBorder("Config"));
				{
					// --- save configuration ---
					saveConfigButton = new JButton();
					// --- add save action ---
					saveConfigButton.addActionListener(new SaveConfigAction(this, controllerPresenter));
					configManagePanel.add(saveConfigButton, "cell 0 0");
					saveConfigButton.setText("Save");
				}
				{
					// --- load configuration ---
					loadConfigButton = new JButton();
					// --- add load action ---
					loadConfigButton.addActionListener(new LoadConfigAction(this, controllerPresenter));
					configManagePanel.add(loadConfigButton, "cell 0 0");
					loadConfigButton.setText("Load");
				}
				{
					// --- default configuration ---
					defaultConfigButton = new JButton();
					// --- add default action ---
					defaultConfigButton.addActionListener(new DefaultConfigAction(controllerPresenter));
					configManagePanel.add(defaultConfigButton, "cell 0 0");
					defaultConfigButton.setText("Default");
				}
			}
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	

	/**
	 * returns the HashMap with all Actions & TextFields
	 * @return TextField HashMap<String, JTextField>
	 */
	public HashMap<String, JTextField> getTextFieldMap()
	{
		return tFMap;
	}
	

	/**
	 * returns server address string given by user
	 * @return ServerAddress
	 */
	public String getServerAdress()
	{
		return serverTextField.getText();
	}
	

	/**
	 * returns port number given by user or standart port
	 * @return PortNumber
	 */
	public int getPortNumber()
	{
		return Integer.parseInt(portTextField.getText());
	}
	

	/**
	 * set loaded or default configuration to TextFields
	 * @param HashMap(ComponentString, ActionString) conf
	 */
	public void showConfig(HashMap<String, String> conf)
	{
		// --- iterate trough all actions ---
		for (String value : conf.values())
		{
			// --- iterate trough all components ---
			for (String key : conf.keySet())
			{
				// --- if conf.get(key) (action) equals textfield (action) ---
				if (conf.get(key) == value)
				{
					// --- put component string in textfield ---
					tFMap.get(value).setText(key);
				}
			}
		}
	}
}
