/*
 * *********************************************************
 * Copyright (c) 2009 - 2010, DHBW Mannheim - Tigers Mannheim
 * Project: TIGERS - RCU
 * Date: 20.10.2010
 * Author(s): Lukas
 * 
 * *********************************************************
 */

package edu.dhbw.mannheim.tigers.robotcontrolutility.view.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.JFileChooser;

import org.apache.log4j.Logger;

import edu.dhbw.mannheim.tigers.robotcontrolutility.presenter.AControllerPresenter;
import edu.dhbw.mannheim.tigers.robotcontrolutility.presenter.RCUPresenter;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.ControllerPanel;
import edu.dhbw.mannheim.tigers.robotcontrolutility.view.utils.ConfFileFilter;


/**
 * This action loads config from selected file.
 * 
 * @author Lukas
 *
 */


public class LoadConfigAction implements ActionListener
{
	// --------------------------------------------------------------------------
	// --- class variables ------------------------------------------------------
	// --------------------------------------------------------------------------
	private ControllerPanel			panel;
	private AControllerPresenter	cPresenter;
	private JFileChooser				fc		= new JFileChooser();
	private final File				DIR	= new File("configs");

	// --- logger ---
	private Logger						log		= Logger.getLogger(RCUPresenter.class.getName());
	
	// -----------------------------------------------------------------
	// ----- Constructor -----------------------------------------------
	// -----------------------------------------------------------------
	public LoadConfigAction(ControllerPanel panel, AControllerPresenter cPresenter)
	{
		this.panel = panel;
		this.cPresenter = cPresenter;
		fc.setFileFilter(new ConfFileFilter());
		fc.setCurrentDirectory(DIR);
	}
	

	// -----------------------------------------------------------------
	// ----- Methods ---------------------------------------------------
	// -----------------------------------------------------------------	
	public void actionPerformed(ActionEvent arg0)
	{
		int returnVal = fc.showOpenDialog(panel);
		if (returnVal == JFileChooser.APPROVE_OPTION)
		{
			File file = fc.getSelectedFile();
			log.info("Opening: " + file.getName());
			cPresenter.loadCurrentConfig(file);
		}
	}
}