/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package edu.dhbw.mannheim.tigers.sim.settings.data.util;

import edu.dhbw.mannheim.tigers.sim.settings.data.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see edu.dhbw.mannheim.tigers.sim.settings.data.IDataPackage
 * @generated
 */
public class DataSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static IDataPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataSwitch() {
		if (modelPackage == null) {
			modelPackage = IDataPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case IDataPackage.SIM_PROPERTIES: {
				ISimProperties simProperties = (ISimProperties)theEObject;
				T result = caseSimProperties(simProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.MATCH_MODE_PROPERTIES: {
				IMatchModeProperties matchModeProperties = (IMatchModeProperties)theEObject;
				T result = caseMatchModeProperties(matchModeProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.TEST_MODE_PROPERTIES: {
				ITestModeProperties testModeProperties = (ITestModeProperties)theEObject;
				T result = caseTestModeProperties(testModeProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.SHOOTER_MODE_PROPERTIES: {
				IShooterModeProperties shooterModeProperties = (IShooterModeProperties)theEObject;
				T result = caseShooterModeProperties(shooterModeProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.CAM_PROPERTIES: {
				ICamProperties camProperties = (ICamProperties)theEObject;
				T result = caseCamProperties(camProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.SIM_ENGINE_PROPERTIES: {
				ISimEngineProperties simEngineProperties = (ISimEngineProperties)theEObject;
				T result = caseSimEngineProperties(simEngineProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.APPLICATION_PROPERTIES: {
				IApplicationProperties applicationProperties = (IApplicationProperties)theEObject;
				T result = caseApplicationProperties(applicationProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.VISUALIZATION_PROPERTIES: {
				IVisualizationProperties visualizationProperties = (IVisualizationProperties)theEObject;
				T result = caseVisualizationProperties(visualizationProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case IDataPackage.TEAM_PROPERTIES: {
				ITeamProperties teamProperties = (ITeamProperties)theEObject;
				T result = caseTeamProperties(teamProperties);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sim Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sim Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSimProperties(ISimProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Match Mode Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Match Mode Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMatchModeProperties(IMatchModeProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Test Mode Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Test Mode Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTestModeProperties(ITestModeProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Shooter Mode Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Shooter Mode Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseShooterModeProperties(IShooterModeProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Cam Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Cam Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCamProperties(ICamProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sim Engine Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sim Engine Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSimEngineProperties(ISimEngineProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Application Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Application Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseApplicationProperties(IApplicationProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Visualization Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Visualization Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVisualizationProperties(IVisualizationProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Team Properties</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Team Properties</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTeamProperties(ITeamProperties object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //DataSwitch
