package edu.dhbw.mannheim.tigers.sim;

import edu.dhbw.mannheim.tigers.sim.controller.MainController;
import edu.dhbw.mannheim.tigers.sim.engine.SimEngineSettings;


/**
 * This is the entry point to the TIGERS-SSL-Simulator. It contains nothing more then the {@link #main(String[])} and
 * some static path-conventions
 * 
 * @author Gero
 */
public class Sim {
	
	public static final String	PROPERTIES_PATH			= "properties/";
	public static final String	SETTINGS_PATH				= PROPERTIES_PATH + "sim.xml";
	public static final String	MODEL_PROPERTIES_PATH	= PROPERTIES_PATH + "model.xml";
	public static final String	ENGINE_SETTINGS_PATH		= SimEngineSettings.ENGINE_SETTINGS_PATH;
	public static final String	SCREENSHOT_PATH			= "screenshots/";
	public static final String	VIDEOS_PATH					= "videos/";
	public static final String	PLUGIN_PATH					= "plugins/";
	
	public static final String	RESOURCE_PATH				= "resources/";
	public static final String	IMAGE_PATH					= RESOURCE_PATH + "images/";
	public static final String	MODEL_PATH					= RESOURCE_PATH + "model/";
	// public static final String MATERIALS_PATH = "resources/model/materials.xml";
	
	public static final String	VERSION_TAG					= "v2.3";
	
	public static final String	LOGGER_LAYOUT				= "%d{HH:mm:ss,SSS} %-5p [%t|%C{1}] %m%n";
	
	
	/**
	 * Entry point to the simulator=)
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		
		String level = "";
		
		if (args.length >= 1) {
			level = args[0];
		}
		new MainController(level);
	}
}
