package edu.dhbw.mannheim.tigers.sim.controller;

import org.apache.log4j.Logger;

import edu.dhbw.mannheim.tigers.sim.controller.MainController.Type;
import edu.dhbw.mannheim.tigers.sim.engine.observer.ASimEngineObserver;


/**
 * Base class for sub-controllers of the {@link MainController} that handle the applications state.
 * 
 * @author Gero
 */
public abstract class ASubController extends ASimEngineObserver {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	protected Logger									log			= Logger.getLogger(getClass());
	
	protected final MainController				main;
	private final Type								type;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @see ASubController
	 * @param main
	 * @param type
	 */
	public ASubController(MainController main, Type type) {
		super(null, false, type.toString());
		
		this.main = main;
		this.type = type;
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	public abstract boolean verifyAppExit();
	

	public abstract void prepareAppExit();
	

	public Type getType() {
		return type;
	}
	

	@Override
	public String toString() {
		return "SubController [" + type + "]";
	}
}
