package edu.dhbw.mannheim.tigers.sim.controller;

import edu.dhbw.mannheim.tigers.sim.engine.ISimEngine;
import edu.dhbw.mannheim.tigers.sim.engine.SimEngine;
import edu.dhbw.mannheim.tigers.sim.engine.modes.ESimEngineMode;


/**
 * Interface that provides access to the {@link SimEngine} to any parts of the application outside sim.controller
 * 
 * @author Gero
 */
public interface ISimEngineController {
	

	/**
	 * @return Returns access to the {@link SimEngine} itself
	 */
	public ISimEngine getSimEngine();
	

	/**
	 * Creates a new SimEngine with the given mode. If there is already one, it is stopped and deleted
	 * 
	 * @param mode
	 * @return Whether there had been an old Engine
	 */
	public boolean createSimEngine(ESimEngineMode mode);
}
