package edu.dhbw.mannheim.tigers.sim.engine.adapter;

import org.apache.log4j.Logger;

import edu.dhbw.mannheim.tigers.sim.engine.ICore;
import edu.dhbw.mannheim.tigers.sim.engine.ISimEnginePart;
import edu.dhbw.mannheim.tigers.sim.engine.SimEngine;
import edu.dhbw.mannheim.tigers.sim.engine.modes.ASimEngineMode;
import edu.dhbw.mannheim.tigers.sim.engine.observer.AStatefulSimEngineObserver;


/**
 * <p>This is the base class for any entities that connect the internals of the {@link SimEngine} (or
 * any {@link ASimEngineMode}) with any kind of influence from outside.
 * </p>
 * 
 * @author Gero
 */
public abstract class ASimEngineAdapter extends AStatefulSimEngineObserver {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	protected final Logger log = Logger.getLogger(getClass());
	
	protected final ICore core;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	  * @see ASimEngineAdapter
	  * @param name
	  * @param core
	  */
	public ASimEngineAdapter(String name, ICore core) {
		super(null, false, name);
		
		this.core = core;
	}
	
	
	/**
	 * Called at the end of the life-cycle of this adapter
	 * @see ISimEnginePart#cleanup()
	 */
	public abstract void cleanup();
}
