package edu.dhbw.mannheim.tigers.sim.engine.com.bot;

import edu.dhbw.mannheim.tigers.sim.engine.com.ERoboCupTeam;
import edu.dhbw.mannheim.tigers.sim.engine.com.IRoboCupControlProvider;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.IBasicBotModelControl;


/**
 * The interface that creates the different types of bot controller
 * 
 * @author Gero
 */
public interface IBotControllerFactory {
   
   
   /**
    * Creates the appropriate {@link ABotController} to the given {@link IBasicBotModelControl}.<br/>
    * <b>May be <code>null</code> if there is not controller for the bot type!!!</b>
    * 
    * @param botControl
    * @param controlProvider
    * @param port The port the controller may need to listen on
    * @param team The {@link ERoboCupTeam} the bot will be in
    * @return
    */
   public ABotController<?, ?, ?> createBotController(IBasicBotModelControl botControl,
         IRoboCupControlProvider controlProvider, int port, ERoboCupTeam team);
}
