package edu.dhbw.mannheim.tigers.sim.engine.com.bot.tiger;

import org.apache.log4j.Logger;

import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.botmanager.commands.ACommand;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.botmanager.commands.CommandConstants;
import edu.dhbw.mannheim.tigers.sumatra.model.modules.impls.botmanager.commands.CommandFactory;

/**
 * Simple parser for {@link ACommand}s
 * 
 * @author Gero
 */
public class TigerCommandParser {
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private final Logger log = Logger.getLogger(getClass());
	

	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	  * @see TigerCommandParser
	  */
	public TigerCommandParser() {
		
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @param buffer
	 * @return The {@link ACommand} parsed from the given buffer. (Or <code>null</code> if header could not be parsed!)
	 */
	public ACommand readCommand(byte[] buffer) {
		byte[] header = new byte[CommandConstants.HEADER_SIZE];
		System.arraycopy(buffer, 0, header, 0, CommandConstants.HEADER_SIZE);
		
		ACommand readCmd = CommandFactory.createEmptyPacket(header);
		
		if (readCmd == null) {
			log.debug("Unable to read command-header!");
			return null;
		}
		
		byte[] data = new byte[readCmd.getDataLength()];
		System.arraycopy(buffer, CommandConstants.HEADER_SIZE, data, 0, readCmd.getDataLength());
		
		readCmd.setData(data);
		
		return readCmd;
	}
	

	// --------------------------------------------------------------------------
	// --- getter/setter --------------------------------------------------------
	// --------------------------------------------------------------------------
}
