package edu.dhbw.mannheim.tigers.sim.engine.delegates;


import com.jme.renderer.Camera;

import edu.dhbw.mannheim.tigers.sim.engine.ICore;
import edu.dhbw.mannheim.tigers.sim.engine.model.CamHelper;


/**
 * Adds a free, first-person camera to the simulation
 * 
 * @author Gero
 */
public class FreeCameraDelegate extends ASimDelegate {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @see FreeCameraDelegate
	 * @param core
	 */
	public FreeCameraDelegate(ICore core) {
		super(core);
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	public void initSystem() {
		
		Camera cam = CamHelper.createCam(core.getDisplay(), core.getDisplayWidth(), core.getDisplayHeight());
		
		core.setCam(cam);
		core.getDisplay().getRenderer().setCamera(cam);
	}
	

	@Override
	public void update(float interpolation, float tpf, float fps) {
		core.getCamera().update();
	}
}
