package edu.dhbw.mannheim.tigers.sim.engine.model;

import edu.dhbw.mannheim.tigers.sim.engine.model.ball.IBallModelDataProvider;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.IBotModelDataProvider;
import edu.dhbw.mannheim.tigers.sim.engine.model.field.IRoboCupFieldDataProvider;
import edu.dhbw.mannheim.tigers.sim.engine.model.material.IMaterialProvider;
import edu.dhbw.mannheim.tigers.sim.resources.IResourceProvider;


/**
 * Tagging interface that provides access to model-data of all types
 * 
 * @author Gero
 */
public interface IModelDataProvider extends IRoboCupFieldDataProvider, IBotModelDataProvider, IBallModelDataProvider, IResourceProvider, IMaterialProvider {
	
	public static final IModelDataProvider INSTANCE = ModelDataProvider.getInstance();
}
