package edu.dhbw.mannheim.tigers.sim.engine.model.bot;

import edu.dhbw.mannheim.tigers.sim.engine.model.IBasicModelControl;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.observer.IBotModelObservable;


/**
 * This interface gives internal parts some basic control over the bot without owning it completely.
 * 
 * @author Gero
 */
public interface IBasicBotModelControl extends IBasicModelControl, IBotModelObservable {

	/**
	 * @return The {@link BotID} identifying this robot in the simulation
	 */
	public BotID getID();
	
	/**
	 * @return some information about the bot
	 */
	public String getInfoText();
	
	/**
	 * @param info - some information about the bot
	 */
	public void setInfoText(String info);
	
	
	/**
	 * @return The {@link EBotModelType} of this bot-model
	 */
	public EBotModelType getBotType();
}
