package edu.dhbw.mannheim.tigers.sim.engine.model.bot;

import edu.dhbw.mannheim.tigers.sim.engine.model.data.bot.ICTBotModelData;
import edu.dhbw.mannheim.tigers.sim.engine.model.data.bot.ITigerBotModelData;



/**
 * This defines which methods has to be provided by a class that provides bot model data.
 * 
 * @author Gero
 */
public interface IBotModelDataProvider {
	
   /**
    * @param type The model type
    * @return The {@link ICTBotModelData} object for the given type, generally loaded from a *.xml-File
    */
	public abstract ICTBotModelData getCTBotModelData(String type);

   /**
    * @param type The model type
    * @return The {@link ITigerBotModelData} object for the given type, generally loaded from a *.xml-File
    */
	public abstract ITigerBotModelData getTigerBotModelData(String type);
}