package edu.dhbw.mannheim.tigers.sim.engine.model.bot.observer;


import com.jme.math.Vector3f;

import edu.dhbw.mannheim.tigers.sim.engine.model.TimedModelLocation;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.BotID;


/**
 * Data-holder which maps the {@link TimedModelLocation} of a bot with a {@link BotID}. This is used to notify the bots
 * positions to any listener (the camera-implementation, e.g.)
 * 
 * @author Gero
 */
public class BotLocation extends TimedModelLocation {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private static final long	serialVersionUID	= 660649556783525984L;
	
	private int						id;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	 * @see BotLocation
	 * @param id
	 * @param position
	 * @param orientation
	 * @param timestamp
	 */
	public BotLocation(int id, Vector3f position, float orientation, long timestamp) {
		super(position, orientation, timestamp);
		
		this.id = id;
	}
	

	/**
	 * @see BotLocation
	 * @param id
	 * @param pos
	 */
	public BotLocation(int id, TimedModelLocation pos) {
		this(id, pos.getPosition(), pos.getOrientation(), pos.getTimestamp());
	}
	
	
	// --------------------------------------------------------------------------
	// --- getter/setter --------------------------------------------------------
	// --------------------------------------------------------------------------
	public void setId(int id) {
		this.id = id;
	}
	
	
	public int getId() {
		return this.id;
	}
}
