package edu.dhbw.mannheim.tigers.sim.engine.model.field;

import com.jme.system.DisplaySystem;
import com.jmex.physics.PhysicsSpace;

import edu.dhbw.mannheim.tigers.sim.exceptions.SimModelException;
import edu.dhbw.mannheim.tigers.sim.exceptions.SimModelResourceException;


/**
 * Creates RoboCup fields
 * 
 * @author Gero
 */
public interface IRoboCupFieldFactory {
	
	/**
	 * Returns a {@link RoboCupField} of the given type
	 * 
	 * @param type
	 * @return
	 * @throws SimModelException 
	 * @throws SimModelResourceException
	 */
	public abstract RoboCupField createField(PhysicsSpace space, DisplaySystem display, String type) throws SimModelException, SimModelResourceException;

}