package edu.dhbw.mannheim.tigers.sim.engine.modes;

import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.model.IBasicModelControl;
import edu.dhbw.mannheim.tigers.sim.engine.model.ball.IBallModelControl;
import edu.dhbw.mannheim.tigers.sim.engine.model.bot.IBasicBotModelControl;

/**
 * Provides access to the the control currently available in the simulation
 * 
 * @author Gero
 */
public interface IMatchControlProvider {
	
	/**
	 * @return A list of bot controls of the bots currently in the simulation
	 */
	public List<? extends IBasicBotModelControl> getBotControls();
	
	
	/**
	 * @return The {@link IBasicModelControl} for the ball currently in the simulation (may be <code>null</code>!!!)
	 */
	public IBallModelControl getBallControl();
}
