package edu.dhbw.mannheim.tigers.sim.engine.modes;

import edu.dhbw.mannheim.tigers.sim.engine.com.visualization.IVisualizationDataInterpreter;
import edu.dhbw.mannheim.tigers.sim.engine.com.visualization.VisualizationDataReceiver;


/**
 * Simply provides access to a delegate that interprets visualization data
 * 
 * @author Gero
 */
public interface IVisDataInterpreterProvider {
	
	/**
	 * @return An implementation of the {@link IVisualizationDataInterpreter} which can interpret and display data from
	 *         the {@link VisualizationDataReceiver}
	 */
	public IVisualizationDataInterpreter getVisualizationDataInterpreter();
}
