package edu.dhbw.mannheim.tigers.sim.engine.plugins;

import java.util.ArrayList;
import java.util.List;


/**
 * This represents an {@link ASimPlugin}s identifier, simply based on a string
 * 
 * @author Gero
 */
public class PluginID {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	public final String base;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	  * @see PluginID
	  * @param base
	  */
	public PluginID(String base) {
		this.base = base;
	}
	
	
	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	public boolean equals(Object obj) {
		boolean equal = false;
		
		if (obj != null) {
		
			if (obj.getClass().equals(getClass())) {
				PluginID otherID = (PluginID) obj;
				equal = this.base.equals(otherID.base);
			} else {
				equal = super.equals(obj);
			}
		}
		
		return equal;
	}
	
	
	/**
	 * @param ids
	 * @return A list of String-representations of the give ids (same order!)
	 */
	public static List<String> toStringList(List<PluginID> ids) {
		List<String> strings = new ArrayList<String>();
		for (PluginID id : ids) {
			strings.add(id.base);
		}
		return strings;
	}
	
	
	@Override
	public int hashCode() {
	   int hc = 17;
	   int hashMultiplier = 59;
	   
		hc = hc * hashMultiplier + ((base == null) ? 0 : base.hashCode());

		return hc;
	}
	
	
	@Override
	public String toString() {
		return "<" + base + ">";
	}
}
