package edu.dhbw.mannheim.tigers.sim.engine.plugins.cam;

import java.util.List;

import org.apache.commons.configuration.SubnodeConfiguration;

import edu.dhbw.mannheim.tigers.sim.engine.model.TimedModelLocation;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.PluginID;


/**
 * Creates cam-output in the most dump way by simply forwarding the real positions
 * 
 * @author Gero
 */
public class DefaultCamOutput extends ACamOutputPlugin {
	public static final PluginID	ID			= new PluginID("DEFAULT_ONE_CAM");
	
	
	public DefaultCamOutput(SubnodeConfiguration config) {
		super(config);
	}
	
	
	@Override
	protected void createCameras(List<ACam> cameras) {
		cameras.add(new SimpleCam(0));
	}
	

	@Override
	public void checkConfigConsistency(SubnodeConfiguration config) {
		// No properties yet!
	}
	

	@Override
	public PluginID getID() {
		return ID;
	}
	
	
	private static class SimpleCam extends ACam {
		public SimpleCam(int id) {
			super(id);
		}
		

		@Override
		protected boolean isObjVisible(TimedModelLocation obj) {
			return true;
		}
	}
}
