package edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization;

import java.util.List;

import org.apache.commons.configuration.SubnodeConfiguration;

import com.jme.scene.Node;
import com.jme.system.DisplaySystem;

import edu.dhbw.mannheim.tigers.sim.engine.modes.IMatchControlProvider;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.ASimPlugin;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.EPluginType;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.visualization.SimVisMessages.SimVisData.Poi;


/**
 * This is the base-class for all plugins of type {@link EPluginType#VISUALIZATION}
 * 
 * @author Gero
 * 
 */
public abstract class AVisualizationPlugin extends ASimPlugin {
	
	/**
	  * @see AVisualizationPlugin
	  * @param config
	  */
	public AVisualizationPlugin(SubnodeConfiguration config) {
		super(config);
	}
	
	
	/**
	 * @param root The node visual representations of {@link Poi}s are attached to
	 * @param display The {@link DisplaySystem} that displays these visualizations
	 * @param matchControl Grants access to the robots and the ball
	 * @return A list of {@link IDrawer}s that should handle incoming {@link SimVisData}-packages
	 */
	public abstract List<IDrawer> getPoiDrawers(Node root, DisplaySystem display, IMatchControlProvider matchControl);
}
