package edu.dhbw.mannheim.tigers.sim.gui.swing.settings;


import java.util.List;

import edu.dhbw.mannheim.tigers.sim.engine.plugins.ASimPlugin;
import edu.dhbw.mannheim.tigers.sim.engine.plugins.IPluginProvider;
import edu.dhbw.mannheim.tigers.sim.gui.swing.SwingGUI;


/**
 * This allows the user to change the settings of the currently loaded plugins!
 * 
 * @author Gero
 */
public class PluginSettingsFrame extends ASettingsFrame {
	
	// --------------------------------------------------------------------------
	// --- variables and constants ----------------------------------------------
	// --------------------------------------------------------------------------
	private static final long	serialVersionUID	= 8777949564519842604L;
	
	
	// --------------------------------------------------------------------------
	// --- constructors ---------------------------------------------------------
	// --------------------------------------------------------------------------
	/**
	  * @see PluginSettingsFrame
	  * @param gui
	  */
	public PluginSettingsFrame(SwingGUI gui) {
		super(gui);
	}
	

	// --------------------------------------------------------------------------
	// --- methods --------------------------------------------------------------
	// --------------------------------------------------------------------------
	@Override
	protected void addSettingsPanels(List<ASettingsPanel> panels, SwingGUI gui) {
		
		List<ASimPlugin> plugins = IPluginProvider.INSTANCE.getLoadedPlugins();
		
		for (ASimPlugin plugin : plugins) {
			panels.add(new PluginSettingsPanel(plugin.getID().base, gui.getInputController(), plugin
					.getConfig()));
		}
	}
	

	@Override
	protected void onCancel() {
		close();
	}
	

	@Override
	protected void onOk() {
		IPluginProvider.INSTANCE.saveLoadedPluginsProperties();
		
		this.dispose();
	}
}
