package edu.dhbw.mannheim.tigers.sim.util;

import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.NotSerializableException;
import java.io.Serializable;

import org.apache.log4j.Logger;


/**
 * A simple class that handles de-/ serialization of objects for you.
 * 
 * @author Gero
 *
 */
public class Serializer {
	
	private static Logger log = Logger.getLogger(Serializer.class);
	
	
	public static String serializeObject(Object object) {

		String result = "";
		try {
			if (!(object instanceof Serializable) || object == null) {
					throw new NotSerializableException("Object could not be serialized!");
			}
			
			ByteArrayOutputStream bos = new ByteArrayOutputStream();

			XMLEncoder encoder = new XMLEncoder(bos);
			encoder.writeObject(object);
			encoder.flush();
			encoder.close();
			
			result = bos.toString();

		} catch (NotSerializableException exc) {
			log.error("Couldn't serialize object!", exc);
		}
		
		return result;
	}
	
	
	@SuppressWarnings("unchecked")
	public static <T> T deserializeString(String objectsRepresentation) {
		
		T castedObject = null;
		
		try {
			if ((objectsRepresentation == null) || objectsRepresentation.isEmpty()) {
					throw new NotSerializableException("Given string is null or emtpy!");
			}
			
			ByteArrayInputStream bis = new ByteArrayInputStream(objectsRepresentation.getBytes());
			
			XMLDecoder is = new XMLDecoder(bis);
			Object readObject = is.readObject();
			is.close();
			
			castedObject = (T) readObject;
		} catch (NotSerializableException exc) {
			log.error("Couldn't deserialize string!", exc);
		} catch (ClassCastException exc) {
			log.error("Couldn't deserialize string!", exc);
		}
		
		return castedObject;
	}
}
