package edu.dhbw.mannheim.tigers.sim.util.activeobserver;


/**
 * {@link AActiveObserver}
 * 
 * @param <S> Observable type (Subject)
 * @param <O> Observer type
 * @param <E> Event type
 */
public interface IActiveObservable<S extends IActiveObservable<S, O, E>, O extends IActiveObserver<S, O, E>, E> {
	
	/**
	 * Notifies all registered observers, that there is a new event - the given.
	 * 
	 * @param event: The {@link Event} that changed the model
	 */
	public abstract void notifyObservers(E event);
	

	/**
	 * Notifies all registered observers, using the last given event.
	 */
	public abstract void notifyObservers();
	

	public abstract boolean addObservers(O... observers);
	

	public abstract boolean removeObserver(O observer);
}