package edu.dhbw.mannheim.tigers.sim.util.observer;



/**
 * <p>
 * The sim's own implementation of the Observer-Pattern.
 * </p>
 * 
 * @author Gero
 * 
 * @param	<S>	Observable type (Subject)
 * @param	<O>	Observer type
 * @param	<E>	Event type
 */
public interface IObserver<S extends IObservable<S, O, E>, O extends IObserver<S, O, E>, E> {
	
	/**
	 * Calls the oObserver with the observable and the event
	 * 
	 * @param observable
	 * @param event
	 */
	void update(IObservable<S, O, E> observable, E event);
}
