/*
 * @(#)UnknownLeafAtom.java
 *
 * $Date: 2010-07-08 21:38:05 -0500 (Thu, 08 Jul 2010) $
 *
 * Copyright (c) 2009 by Jeremy Wood.
 * All rights reserved.
 *
 * The copyright of this software is owned by Jeremy Wood. 
 * You may not use, copy or modify this software, except in  
 * accordance with the license agreement you entered into with  
 * Jeremy Wood. For details see accompanying license terms.
 * 
 * This software is probably, but not necessarily, discussed here:
 * http://javagraphics.blogspot.com/
 * 
 * And the latest version should be available here:
 * https://javagraphics.dev.java.net/
 */
package com.bric.qt.io;

import java.io.IOException;

import com.bric.io.GuardedInputStream;
import com.bric.io.GuardedOutputStream;

public class UnknownLeafAtom extends LeafAtom {
	byte[] data;
	String id;
	
	public UnknownLeafAtom(String id,byte[] data) {
		super(null);
		this.id = id;
		this.data = data;
	}
	
	public UnknownLeafAtom(Atom parent,String id,GuardedInputStream in) throws IOException {
		super(parent);
		this.id = id;
		data = new byte[(int)in.getRemainingLimit()];
		read(in,data);
	}
	
	protected String getIdentifier() {
		return id;
	}

	protected long getSize() {
		return 8+data.length;
	}

	protected void writeContents(GuardedOutputStream out) throws IOException {
		out.write(data);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		for(int a = 0; a<Math.min(data.length,64); a++) {
			sb.append( (char)data[a] );
		}
		if(data.length>64)
			sb.append("...");
		return "UnknownLeafAtom[ \""+sb.toString()+"\" ]";
	}
}
